/*
 * Cell.cpp
 *
 *  Created on: 23 Oct 2013
 *      Author: np183
 */

#include <iostream>
#include <string>
#include <sstream>
#include "Cell.hpp"

using std::string;
using std::stringstream;
using std::ostream;
using std::cout;
using std::endl;

const unsigned int MAXNUM = 0-1;

Cell::Cell() : _left(0), _right(0), _up(0), _down(0), _x(MAXNUM), _y(MAXNUM), _contents(0) {
}

Cell::Cell(unsigned int x,unsigned int y,int contents)
: _left(0), _right(0), _up(0), _down(0), _x(x), _y(y), _contents(contents)
{}

Cell::~Cell() {
	_left=0;
	_right=0;
	_up=0;
	_down=0;
}

Cell* Cell::left() const {
	return _left;
}
Cell* Cell::right() const {
	return _right;
}
Cell* Cell::up() const {
	return _up;
}
Cell* Cell::down() const {
	return _down;
}
unsigned int Cell::x() const {
	return _x;
}
unsigned int Cell::y() const {
	return _y;
}
int Cell::contents() const {
	return _contents;
}

void Cell::setLeft(Cell* left) {
	_left = left;
}
void Cell::setRight(Cell* right) {
	_right = right;
}
void Cell::setUp(Cell* up) {
	_up = up;
}
void Cell::setDown(Cell* down) {
	_down = down;
}
void Cell::setX(unsigned int x) {
	_x = x;
}
void Cell::setY(unsigned int y) {
	_y = y;
}
void Cell::setContents(int contents) {
	_contents = contents;
}


string Cell::toString() const {
	stringstream temp;
	temp << "(" << _x << "," << _y << "," << _contents << ")";
	return temp.str();
}

ostream& operator<< (ostream& stream, const Cell& cell) {
	stream << cell.toString();
	return stream;
}
