/*
 * Cell.hpp
 *
 *  Created on: 23 Oct 2013
 *      Author: np183
 */

#ifndef CELL_HPP_
#define CELL_HPP_

#include <iostream>
#include <string>

class Cell {
public:
	Cell();
	Cell(unsigned int x,unsigned int y,int contents);

	~Cell();

	Cell* left() const;
	Cell* right() const;
	Cell* up() const;
	Cell* down() const;
	unsigned int x() const;
	unsigned int y() const;
	int contents() const;

	void setLeft(Cell*);
	void setRight(Cell*);
	void setUp(Cell*);
	void setDown(Cell*);
	void setX(unsigned int);
	void setY(unsigned int);
	void setContents(int);

	std::string toString() const;

	friend std::ostream& operator<<(std::ostream&,const Cell&);

private:
	Cell* _left;
	Cell* _right;
	Cell* _up;
	Cell* _down;
	unsigned int _x;
	unsigned int _y;
	int _contents;
};


#endif /* CELL_HPP_ */
