/*
 * main.cpp
 *
 */


#include <iostream>
#include <string>
#include <sstream>
#include "Cell.hpp"


using std::cout;
using std::cin;
using std::endl;

int main() {
  Cell  cell1(0,0, 88), cell2(0,2,56), cell3(3,1, 121), cell4(3,5,42);
  Cell* p1=0;
  Cell* p2=0;
  Cell* p3=0;
  Cell* p4=0;

  cout << "cell1 is "<< cell1<<endl;
  cout << "cell2 is "<< cell2<<endl;
  cout << "cell3 is "<< cell3<<endl;
  cout << "cell4 is "<< cell4<<endl <<endl;

  /*   A multi-linked list where

                    cell1 <-> cell2
                     ^         ^
                     |         |
                     v         v
                    cell4 <-> cell3

       Notice that the locations of the cells are not
       matching to their connectivity.

       The matching sparse matrix would be:
           0   1   2   3   4   5
        |-----------------------
       0| 88      56
       1|
       2|
       3|    121              42

       and the cells would be connected:
       cell1 <-> cell2
       and
       cell4 <-> cell3

       The toString() of this matrix should not issue the
       markings of the locations. Just the numbers inside the
       frame.
  */

  cell1.setRight(&cell2);
  cell1.setDown(&cell4);
  cell2.setLeft(&cell1);
  cell2.setDown(&cell3);
  cell3.setUp(&cell2);
  cell3.setLeft(&cell4);
  cell4.setUp(&cell1);
  cell4.setRight(&cell3);

  /* Construction of same list from pointers,
     no use of variables cell1, cell2, cell3, cell4 */

  p1 = new Cell (0,0,88);
  p2 = new Cell (0,2,56);
  p3 = new Cell (3,1,121);
  p4 = new Cell (3,5,42);

  cout << "*p1 is "<< *p1<<endl;
  cout << "*p2 is "<< *p2<<endl;
  cout << "*p3 is "<< *p3<<endl;
  cout << "*p4 is "<< *p4<<endl <<endl;

  (*p1).setRight(p2);
  (*p1).setDown(p4);
  (*p2).setLeft(p1);
  (*p2).setDown(p3);
  (*p3).setUp(p2);
  (*p3).setLeft(p4);
  (*p4).setUp(p1);
  (*p4).setRight(p3);

  /* Constructing a double linked list by asking the user for data
     Notice that the location numbers are ***not*** handled.
  */


  int n;
  Cell* p=0;
  Cell* q=0;
  cout << "Enter an integer: ";
  while (cin >> n) {
      p = new Cell (0,0, n);
      (*p).setRight(q);
      if (q !=0)
         (*q).setLeft(p);
      q = p;
      cout << "Enter an integer: ";
  };

  while (p !=0) {
     cout << (*p).contents();
      p=(*p).right();
     if (p !=0)
       cout << "<->";
     else
       cout << "\n";
  }


}
